<?PHP

/**
 * Simpla CMS
 *
 * @copyright 	2010 Redline Studio
 * @link 		http://rlstudio.com
 * @author 		Art Mitrofanov
 *
 * Отображение ленты RSS версии 2
 *
 */
 
require_once('Widget.class.php');

class RSS extends Widget
{
    function RSS(&$parent)
    {
    parent::Widget($parent);
    $this->prepare();
    }

    function prepare()
    {
    }
	
	/**
	 *
	 * Отображение
	 *
	 */
	function fetch()
    {
        if($this->param('type') == 'articles')
        {
            // Выбераем статьи из базы
            $this->db->query('SELECT *, DATE_FORMAT(created, \'%a, %d %b %Y %H:%i:%s +0200\') as date FROM articles WHERE enabled=1 ORDER BY order_num LIMIT 10');
            $items = $this->db->results(); 
            
            $url = 'articles';  
            $category = 'Статьи'; 
        }
        else
        {
            // Выбераем новости из базы
            $this->db->query('SELECT *, DATE_FORMAT(date, \'%a, %d %b %Y %H:%i:%s +0200\') as date FROM news WHERE enabled=1 ORDER BY news.date DESC LIMIT 10');
            $items = $this->db->results();    
                      
            $url = 'news'; 
            $category = 'Новости';            
        }

        $ctype="text/xml";
        header("Pragma: public");
        header("Expires: 0");
        header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
        header("Content-Type: text/xml; charset=UTF-8");
        header('Content-disposition: inline; filename="'.$url.'.rss"');
        header("Content-Transfer-Encoding: binary");
        print "<?xml version='1.0' encoding='utf-8'?>\n";
        print "<rss version='2.0' xmlns:dc='http://purl.org/dc/elements/1.1/'>\n";
        print "<channel>\n";
        print "<title>".$settings->site_name."</title>\n";
        print "<link>".$this->root_url."</link>\n";
        print "<description>".$settings->company_name."</description>\n";
        print "<language>ru-ru</language>\n";
        print "<copyright>Copyright ".date('Y')." ".$settings->company_name."</copyright>\n"; 
        // Items    
        foreach($items as $item)
        {
            print "<item>\n";
            print "\t<title>".htmlspecialchars($item->header, ENT_QUOTES)."</title>\n";
            print "\t<link>http://".$this->root_url."/".$url."/".urlencode($item->url)."</link>\n";
            print "\t<description><![CDATA[".strip_tags($item->annotation, '<p><b><ul><li><strong><i><em>')."]]></description>\n";
            print "\t<category>".$category."</category>\n";
            print "\t<pubDate>".$date."</pubDate>\n";
            print "</item>\n";             
        }     
        print "</channel>\n";     
        print "</rss>\n";     
		
		exit();
	}
}

